CREATE TABLE IF NOT EXISTS Hash(
    id INTEGER,
    hash TEXT UNIQUE, /* snix-castore node */
    n_bytes INTEGER,
    PRIMARY KEY(id)
) STRICT; /* Essentially random strings */
CREATE TABLE IF NOT EXISTS Str(
    id INTEGER,
    str TEXT UNIQUE,
    PRIMARY KEY(id)
) STRICT; /* "Naturally occuring" strings */
CREATE TABLE IF NOT EXISTS SidxUriSample(
    id INTEGER,
    uri INTEGER NOT NULL,
    hash INTEGER,
    epoch INTEGER NOT NULL DEFAULT (unixepoch()),
    http_code INTEGER DEFAULT NULL,
    content_type INTEGER DEFAULT NULL,
    PRIMARY KEY(id),
    FOREIGN KEY(uri) REFERENCES Str(id),
    FOREIGN KEY(hash) REFERENCES Hash(id),
    FOREIGN KEY(content_type) REFERENCES Str(id)
) STRICT;
CREATE INDEX IF NOT EXISTS SidxUriHashIdx
ON SidxUriSample(uri, hash, epoch);

CREATE TABLE IF NOT EXISTS "UriReference" (
	"id"	INTEGER,
	"content"	INTEGER NOT NULL,
	"target"	INTEGER NOT NULL,
	"why"	INTEGER,
	PRIMARY KEY("id"),
	CONSTRAINT "NoDupRefs" UNIQUE("content","target","why"),
	FOREIGN KEY("content") REFERENCES "Hash"("id"),
	FOREIGN KEY("target") REFERENCES "Str"("id"),
	FOREIGN KEY("why") REFERENCES "Str"("id")
) STRICT;
